// BERT.CPP - Bit Error Rate Tester (1K2 modem)
// --------------------------------------------------------------------------
// (C) 23.3.96 Jrgen Hasch, DG1SCR@DB0RBS (hasch@ihf.uni-stuttgart.de)
// V1.0

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include <ctype.h>
#include <string.h>

#include "rs232.hpp"

#define TRUE     1
#define FALSE    0
#define WAITTIME 100
#define MAXGAIN  16
#define PGUP     73
#define PGDOWN   81
#define STEP 0.1
static RS232 *com;

int verbose = FALSE;    // keine Meldungen ausgeben
int poly1[10],poly2[10],poly3[10],poly4[10];
int gain=0;             // Eingangsverstrkung des Codec
int trigger;            // Trigger-Typ
int level;              // Trigger-Level

int buf1[32];
int buf2[32];
int buf3[32];
int buf4[32];
char *fs;            // Wandlungsfrequenz
double ts;           // Periode
int OFFSET = 0;      // DC-Offset
double SCALE = 1.0;     // Skalierung
int mono=FALSE;
int pause=FALSE;

int c2n(char c)
{
int n;
  n = c - 0x30;
  if (n > 9)
    n = _toupper(c) - 'A' + 10;
  return n;
}

//
// hex-string in zahl umwandeln (1,2 oder 3-stellig)
//
int hex2i(char *str)
{
int len;

  len = strlen(str);
 if (len == 1)
   return c2n(*str);
 if (len == 2)
   return 16*c2n(*str) + c2n(*(str+1));
 if (len == 3)
   return 256*c2n(*str) + 16*c2n(*(str+1)) + c2n(*(str+2));
 return 0;
}
//
// Bildschirmmaske aufbauen
//
void initbs()
{
char tmp[80];
int x,y,i;

  setcolor(BLUE);
  cleardevice();
  setcolor(WHITE);
  // Rahmen
  lineto(639,0); lineto(639,479); lineto(0,479); lineto(0,0);
  line(0,20,639,20);
  line(0,21,639,21);
  outtextxy(20,7,"BERT V1.0");

  outtextxy(100,27,"Received signal");
  outtextxy(100,222,"Demodulator output");

  poly1[0] = 40 ; poly2[0] = 40 ; poly3[0] = 360; poly4[0] = 360;
  poly1[1] = 40 ; poly2[1] = 240; poly3[1] = 40 ; poly4[1] = 240;
  poly1[2] = 40 ; poly2[2] = 40 ; poly3[2] = 360; poly4[2] = 360;
  poly1[3] = 200; poly2[3] = 400; poly3[3] = 600; poly4[3] = 400;
  poly1[4] = 482; poly2[4] = 482; poly3[4] = 582; poly4[4] = 582;
  poly1[5] = 200; poly2[5] = 400; poly3[5] = 600; poly4[5] = 400;
  poly1[6] = 482; poly2[6] = 482; poly3[6] = 582; poly4[6] = 582;
  poly1[7] = 40 ; poly2[7] = 240; poly3[7] = 40 ; poly4[7] = 240;
  poly1[8] = 40 ; poly2[8] = 40 ; poly3[8] = 360; poly4[8] = 360;
  poly1[9] = 40 ; poly2[9] = 240; poly3[9] = 40 ; poly4[9] = 240;

  if (!mono)
    {
    setcolor(LIGHTBLUE);
    fillpoly(4,poly1);
    fillpoly(4,poly2);
    }

  setcolor(WHITE);
  drawpoly(5,poly1);
  drawpoly(5,poly2);

  outtextxy(25,120,"0");
  outtextxy(20,195,"-1");
  outtextxy(25,45,"1");

  outtextxy(25,320,"0");
  outtextxy(20,395,"-1");
  outtextxy(25,245,"1");

}

//
// Daten empfangen und auf Bildschirm darstellen
//
void display()
{
int xpos,i;
char c1,c2,c3,c4;
char tmp[40];
unsigned int bitcnt1,bitcnt2,bitcnt3;
unsigned int errcnt1,errcnt2,errcnt3;
unsigned long bitcnt, errcnt;
double f;
double ti,tq;

  com->flushInBuf();
  com->txchar('S');
  delay(10);
  
  if (mono)
    setcolor(BLACK);
  else
    setcolor(LIGHTBLUE);

  line(41,120-buf1[0],61,120-buf1[1]);    // RX signa
//  line(41,320-buf3[0],51,320-buf3[1]);    // I arm
//  line(361,320-buf4[0],371,320-buf4[1]);  // Q arm
  
  bitcnt1 = com->rxchar() & 0xff;  
  bitcnt2 = com->rxchar() & 0xff;  
  bitcnt3 = com->rxchar() & 0xff;  
 
  errcnt1 = com->rxchar() & 0xff;  
  errcnt2 = com->rxchar() & 0xff;  
  errcnt3 = com->rxchar() & 0xff;  

 gotoxy(15,1);
 errcnt = 65536 * errcnt3 + 256 * errcnt2 + errcnt1;
 bitcnt = 65536 * bitcnt3 + 256 * bitcnt2 + bitcnt1;
 // Bitfehlerwahrscheinlichkeit ?
 if (bitcnt > 0)
   f = (double)errcnt / (double)bitcnt;
 printf("Scale: %03f Bits: %02x%02x%02x Err: %02x%02x%02x F: %05f",SCALE, bitcnt3,bitcnt2,bitcnt1,errcnt3,errcnt2,errcnt1,f);

  c1=com->rxchar();
  c2=com->rxchar();
  c3=com->rxchar();
  c4=com->rxchar();

  buf1[0] = (int) ( (double)c1*SCALE );
  buf2[0] = (int) ( (double)c2*SCALE );

  setcolor(WHITE);

  for (i=1; i < 23; i++)
    {
    if (mono)
      setcolor(BLACK);
    else
      setcolor(LIGHTBLUE);

    if (i < 22)
      {
     line(41+i*20,120-buf1[i],61+i*20,120-buf1[i+1]);  // alte Linie lschen
//     line(41+i*10,320-buf3[i],51+i*10,320-buf3[i+1]); 
//     line(361+i*10,320-buf4[i],371+i*10,320-buf4[i+1]); 
     }
    c1 = com->rxchar();
    c2 = com->rxchar() ;
    c3 = com->rxchar() ;
    c4 = com->rxchar();

    buf1[i] = (int) ( (double)c1*SCALE );
    buf2[i] = (int) ( (double)c2*SCALE +OFFSET);
    buf3[i] = (int) ( (double)c3*SCALE );
    buf4[i] = (int) ( (double)c4*SCALE );
    
    setcolor(WHITE);
    line(21+i*20,120-buf1[i-1],41+i*20,120-buf1[i]);    // RX
    line(21+i*20,320-buf2[i-1],41+i*20,320-buf2[i]);  // demod
//    line(31+i*10,320-buf3[i-1],41+i*10,320-buf3[i]);  // I
//    line(351+i*10,320-buf4[i-1],361+i*10,320-buf4[i]);  // Q
    }
 delay(10);
}
//

void usage()
{
  cout << "BERT - Bit Error Rate Tester\n";
  cout << "Parameter: -v -c<comport> [oder -b<portaddr> -i<irq>]\n";
  exit(0);
}

int main(int argc, char *argv[])
{
  int gdriver = DETECT, gmode, errorcode;
  char key,c;
  int quit,i;
  int portaddr = 0, portint = 0;
  int comport = 0;

  if (argc > 1)
    {
    i = argc;
    while (--i > 0)
      {
      c = _toupper(*(argv[i]+1));
      if (*argv[i] == '-')
	switch(c)
	  {
	  case '?':
	   usage();
	   break;
	  case 'B':
	    portaddr = hex2i(argv[i]+2);
	    break;
	  case 'I':
	    portint = hex2i(argv[i]+2);
	    break;
	  case 'M':
	    mono=TRUE;
	    break;
	  case 'C':
	     comport = *(argv[i]+2) - 0x30;
	     if (comport < 1 || comport > 4)
	       {
	       cout << "Falsche Angabe : " << argv[i] << "\n";
	       exit(0);
	       }
	   break;
	  case 'V':
	    verbose = TRUE;
	    break;
	  default:
	    cout << "Falscher Parameter: " << argv[i] << "\n";
	    cout << "OSZI -? fr Hilfe\n";
	    exit(0);
	  } // switch
	} // while
      } // if
   else
     usage();

 if (verbose)
  {
  cout << "Comport:   " << comport << "\n";
  cout << "Portaddr:  " << portaddr << "\n";
  cout << "Interrupt: " << portint << "\n";
  }

 if (comport > 0 && portaddr == 0 && portint == 0)
    com = new RS232((unsigned char)comport);
 else
    com = new RS232(38400, portaddr, portint); // COM-Port ffnen
 com->setBaud(38400L);

//  delay(1000);       // warten bis DSP-Karte bereit

  com->flushInBuf();
  // Programm laden
  // und ausfhren...
//  delay(10*WAITTIME);

  initgraph(&gdriver, &gmode, "");

  errorcode = graphresult();
  if (errorcode != grOk)
    {
    printf("Grafik-Fehler: %s\n", grapherrormsg(errorcode));
    printf("...Tastendruck beendet das Programm!");
    delete com;
    getch();
    exit(1);
    }

//  initbs();
//  Skala();
//  moveto(100,250);
  setfillstyle(SOLID_FILL,LIGHTBLUE);
 initbs();
 moveto(100,250);

  quit = 0;
  ts = 1.0/48000.0;

  while (!quit)
    {
    if (!pause)
      display();
    if (kbhit())
      {
      key = getch();
      switch(toupper(key))
	{
	case '+':
	  OFFSET += 5;
	  break;
	case '-':
	  OFFSET -=5; 
	  break;
	case PGUP:
	  if (SCALE < 2.0)
	    SCALE+=STEP;
	  break;
	case PGDOWN:
	  if (SCALE > STEP)
	    SCALE-=STEP;
	  break;
	case 'R':
	  initbs();
	  break;
	case 'X':
	  quit = 1;
	  break;
	case 'P':
	  if (pause)
	    pause = FALSE;
	  else
	    pause = TRUE;
	  break;
	}
      }
   }
   closegraph();
   delete com;
   return 0;
}
